;Zaehler-ELBUG-Messwerte (ZEM) fr die TRX Steuerung
;=========================================================================
;Bernd Kernbaum DK3WX, Fred Heusy DJ3KK
;
;=========================================================================
;
;PIC 4 MHz Quarztakt
;Funktion:

#define ptype	876			; 873 oder 876
#define lcdtype	1			; 1 = i2c-lcd, 2 = lcd
#define zeile	2			; 1 = einzeiliges 2 = zweizeiliges Display

;********************************
	if ptype == 876
;********************************

	list      p=16f876             ; list directive to define processor
	#include <p16f876.inc>         ; processor specific variable definitions
	__config   _cp_off & _lvp_off & _wdt_off & _pwrte_on & _hs_osc

;********************************
	else
;********************************

	list      p=16f873             ; list directive to define processor
	#include <p16f873.inc>         ; processor specific variable definitions
	__config   _cp_off & _lve_off & _wdt_off & _pwrte_on & _hs_osc

;********************************
	endif
;********************************


;==========================================================
; Variablen:
;==========================================================
        org     020h

rette_w:	res     1	; W retten in der ISR  
rette_f:	res     1     	; f retten in der ISR
rette_p:	res     1     	; pclath retten in der ISR

;RAM Zellen ensprechen den EEPROM Zellen
; 16 Zellen mit Reserve

ton:		res	1	;Tonhhe	
tempo:		res     1       ;Tasttempo 
cq_count:	res     1       ;Anzahl der CQ Schleifen und 
				; Bit 4,5,6 Wdh Zeit
				; Bit 7 ZF Addition oder Subtraktion
zf_b2:		res     1       ;
zf_b1:		res     1       ;
zf_b0:		res     1       ;
txhi_mem:	res	1	;TX->RX Delay
fmask:		res	1	;Frequenzausgabemaske
call1:		res	1	;
call2:		res	1	;
call3:		res	1	;
call4:		res	1	;
call5:		res	1	;
call6:		res	1	;
tastv:		res	1	;Tastverhaeltnis
pausev:		res	1	;Pausenverhltnis

freq:		res     1       ;Tonfrequenzspeicher
duratn:		res     1     	;Zeitschleifenspeicher
f_temp:		res     1     	;Tasttempo
txlo:		res	1	;TX->RX Delay
txhi:		res	1	;TX->RX Delay

d_hi:		res     1     	;Zeitschleife High-Wert
d_lo:		res     1     	;Zeitschleife Low-Wert
tgl:		res     1     	;Bitmuster fuer die Tonausgabe port A
t_pat:		res     1     	;Bitmuster fuer die Tonausgabe port A
eing:		res     1     	;Speicher fuer die Eingabe wenn Ausgabe
drei:		res     1     	;Strichlaenge
                      		;laeuft (Punkt Strichspeicher)
z_mem:		res     1     	;Zeichen fuer die aktuelle morseausg
z_anz:		res     1     	;
swrton:	  	res	1
swr_r:	  	res	1
swr_v:	  	res	1
        
decoder:	res	1     	;M-Dekoder

bmem:		res   1         ;
bmem1:		res   1         ;
temp:         	res   1         ;
temp1:          res   1         ;
temp2:          res   1         ;
zeiger:         res   1         ;
zaehler:	res   1         ;
vorteil:	res   1         ;
sum:		res   1         ;
mem:		res   1         ;
cf:		res   1         ;
sr0:		res   1         ;
										
f_h0:		res   1         ;
f_h1:		res   1         ;
f_h2:		res   1         ;
f_h3:		res   1         ;
f_h4:		res   1         ;
f_h5:		res   1         ;
f_h6:		res   1         ;
f_h7:		res   1         ;
f_h8:		res   1         ;
f_h9:		res   1         ;
f_ha:		res   1         ;
f_hb:		res   1         ;
f_hc:		res   1         ;
f_hd:		res   1         ;
f_he:		res   1         ;
f_hf:		res   1         ;
z_a:		res   1         ;
z_b3:		res   1       	;
z_b2:		res   1       	;
z_b1:		res   1       	;
z_b0:		res   1       	;
tw0:		res   1
tw1:		res   1
tw2:		res   1
tw3:		res   1

tmem:		res   1         ;
bitbuf:         res   1         ; Bit buffer
ercode:         res   1         ;  error code (to indicate bus status)
addr:           res   1         ; address register
datai:          res   1         ; stored data input register
datao:          res   1         ; stored data output register
slave:          res   1         ; device address (1010xxx0)
txbuf:          res   1         ; tx buffer
rxbuf:          res   1         ; rx buffer
count:          res   1         ; bit counter
flag:           res   1         ; bit counter
wtime:		res   1		; Wiederholungszeit							

		org	0a0h
rette_w1:	res     1	; W retten in der ISR  

;=========================================================================
;Namen der I/O Leitungen 
;=========================================================================

;port a
#define e_mess_ub	porta,0h        ;Analogeingang Messung Ub
#define e_mess_ret	porta,1h        ;Analogeingang Messung SWR Rcklauf
#define a_tone		porta,2h	;Toneausgang
#define e_mess_vor	porta,3h        ;Analogeingang Messung SWR Vorlauf
#define e_f_in  	porta,4h        ;Zaehlereingang
#define a_tast		porta,5h	;Tastausgang

;********************************
	if	lcdtype == 1
;********************************

;port b mode Taste
#define e_mode   	portb,0h        ;Mode whlen
#define e_start	  	portb,1h        ;Funktion Start/Stop
#define e_speed		portb,2h        ;
#define e_cq2	  	portb,3h        ;
#define e_cq1	  	portb,4h        ;
#define e_handtaste 	portb,5h        ;
#define e_dot   	portb,6h        ;Punkte
#define e_dash  	portb,7h        ;Striche

;port c
#define a_rx_mute  	portc,0h        ;RX Stummschalten
#define a_a1	  	portc,1h        ;
#define a_a2	  	portc,2h        ;
#define a_scl   	portc,3h        ;SCL
#define a_sda   	portc,4h        ;SDA
#define a_tx    	portc,5h	;TX ein
#define a_sio		portc,6h   	;Daten zum PC
#define e_sio   	portc,7h	;Datenempfang vom PC

;********************************
	else
;********************************

;port b mode Taste
#define e_mode   	portb,0h        ;Mode whlen
#define e_start	  	portb,1h        ;Funktion Start/Stop
#define e_speed		portb,2h        ;
#define e_cq2	  	portb,3h        ;
#define e_cq1	  	portb,4h        ;
#define e_handtaste 	portb,5h        ;
#define e_dot   	portb,6h        ;Punkte
#define e_dash  	portb,7h        ;Striche

;port c
#define a_db4  		portc,0h        ;Datenleitungen DB0..3 auf Masse
#define a_db5	  	portc,1h        ;
#define a_db6	  	portc,2h        ;
#define a_db7   	portc,3h        ;
#define lcd_rs   	portc,4h        ;
#define lcd_rw    	portc,5h	;
#define lcd_enable	portc,6h   	;
#define a_tx	   	portc,7h	;

;********************************
	endif
;********************************

;=========================================================================
;Konstanten fuer die PIC-Konfiguration
;=========================================================================
d_option_reg:       	equ   	b'00100111'
d_port_a:           	equ   	00h
d_port_b:           	equ   	00h
d_port_c:           	equ   	00h
d_tmr0:             	equ   	00h
						;0=Ausgang
						;1=Eingang
d_trisa:            	equ   	b'00001011'	;Funktion siehe Definitionen
fmessin:		equ	b'00011011'
fmessout:		equ	b'00001011'
tonport:		equ	b'00000100'
 
d_trisb:            	equ   	b'11111111' 
;********************************
	if	lcdtype == 1
;********************************
d_trisc:            	equ   	b'10011111'

i2cout:			equ	b'10000111'	;Umschaltung I2C port C auf Ausgang
i2cin:			equ	b'10011111'	;Umschaltung I2C port C auf Eingang
i2csdain:		equ	b'10010111'     ; force sda line as input
;********************************
	else
;********************************

d_trisc:            	equ   	b'00000000'

;********************************
	endif
;********************************
 
d_intcon:           	equ   	80h		;global interrupt enable
d_adcon1:           	equ   	04h    		;PortA als digit. I/O - RA0/1/3 analog. Eingang  

d_t1con:		equ	b'00100001'	;Timer 1 intern VT8 go
d_pie1:			equ	b'00000001'	;Timer 1 enable
d_pie2:			equ	b'00000000'	

err1:               	equ   	0h		;Flags
fnull:			equ	1h		;Flags
tonw			equ	2h		;Flags
nodisp:			equ	3h		;Flags
fcq1:			equ	4h		;Flags
fcq2:			equ	5h		;Flags
di:                 	equ     7               ; input
do:                 	equ     6               ; output

;********************************
 if ptype == 876
;********************************

speicher1:		equ	20h		;Speicherplatz 1
speicher2:		equ	80h		;Speicherplatz 2
sp_lang:		equ	5ah		;maximale Anzahl der Zeichen in den Speichern

;********************************
 else
;********************************

speicher1:		equ	20h		;Speicherplatz 1
speicher2:		equ	40h		;Speicherplatz 2
sp_lang:		equ	1eh		;maximale Anzahl der Zeichen in den Speichern

;********************************
 endif
;********************************

bank0:              	equ   	00h
bank1:              	equ   	80h
bank2:              	equ   	100h
bank3:              	equ   	180h

;=========================================================================
; EEPROM Zellen
;=========================================================================
        org 2100h
        data    3f20h           ;Tonhoehe
        data    3fb0h           ;Tempo
        data    3f03h           ;Anzahl der cq Schleifen + bit 7 ZF +/-
        data    3f00h           ;ZF dualer Wert zf_b2
        data    3f00h           ;ZF dualer Wert zf_b1
        data    3f00h		;ZF dualer Wert zf_b0
        data    3f80h		;RX->TX Delay nur der High Wert
        data    3ff8h		;Frequenzausgabemaske

				;call in dual code DK3WX
        data    3f90h		;'10010000'    ;d
        data    3fb0h		;'10110000'    ;k
        data    3f1ch		;'00011100'    ;3
        data    3f70h		;'01110000'    ;w
        data    3f98h		;'10011000'    ;x
        data    3f00h		;call6
        data    3f31h		;Strich/Punkt
        data    3f64h		;Wpause/Zpause

        org 2120h
        data    3fa8h		;'10101000'    ;c
        data    3fd8h		;'11011000'    ;q
        data    3f00h		;'00000000'    ;

;********************************
  if ptype == 876 
;********************************

        org 2180h
        data    3f70h		;'01110000'    ;w
        data    3f98h		;'10011000'    ;x

;********************************
  else
;********************************

        org 2140h
        data    3f70h		;'01110000'    ;w
        data    3f98h		;'10011000'    ;x

;********************************
  endif
;********************************

;=========================================================================
; Hardware initialisieren
;=========================================================================

        org     0
;	goto	test1
	goto	anf
;=========================================================================
;ISR 
;=========================================================================
	org	4
isr:	movwf	rette_w		; W retten
	swapf	status,w	; Flags nach W holen
	clrf	status		; Bank 0 einschalten
	movwf	rette_f		; Flags retten
	movf	pclath,w	; ROM Bank Retten
	movwf	rette_p
	clrf	pclath		; ROM Bank 0
	bcf	status,irp	; RAM Bank 0

;Interrupt RB Change
	btfsc	intcon,0	;test ob RB Portchange Int.
	goto	mtast		;Paddle Int.

;Interruptbehandlung fuer Timer
	clrf	pir1		; Int Flags lschen
	movlw	0ffh		;
	movwf	tmr1h		; Timer 1 High Wert
	movf	swrton,w
	movwf	tmr1l		; Timer 1 Low Wert

	sublw	0f7h		; Tonfolgesteuerung
	btfsc	status,c	;mit konstantem Ton
	goto	isr0
	decfsz	tw0,f		;zwei Reg werden runtergezaehlt
	goto	isr1
	clrf	tw0
	decfsz	tw1,f
	goto	isr1
	movf	tw3,w		;beide Reg neu laden
	movwf	tw1
	movf	tw2,w
	movwf	tw0
	btfss	flag,tonw	;Flag tonw steuert die Halbwellen
	goto	isr2		; ... Ton an und Ton aus 
	bcf	flag,tonw
	goto	isr1

isr2:	bsf	flag,tonw
	goto	isr1

isr1:	btfss	flag,tonw
	goto	iend

isr0:	movf	tgl,w
	andlw	tonport		;Tonausgang ist porta 1
	xorwf	porta,f
	comf	tgl,w
	andlw	tonport		;Tonausgang ist porta 1
	movwf	tgl

;Restaurieren der Register
iend:   
	movf	rette_p,w
	movwf	pclath
	swapf	rette_f,w       ; gerettete Flags in W
        movwf	status          ; Flags restaurieren
        swapf	rette_w,f       ; W restaurieren
        swapf	rette_w,w       ; W restaurieren
        retfie
					
;=========================================================================
;Initialisierung des C 
;=========================================================================
anf:    
        clrf        status        ; Flags loeschen
            
        banksel bank1             ; Registerbank 80h..0AFh
        movlw       d_option_reg
        movwf       option_reg
	movlw	    d_pie1
        movwf       pie1
	movlw	    d_pie2
        movwf       pie2
        movlw       d_trisa
        movwf       trisa
        movlw       d_trisb
        movwf       trisb
        movlw       d_trisc
        movwf       trisc
        movlw       d_adcon1
        movwf       adcon1
        banksel bank0             ; Registerbank 0..2FH
          

        movlw       d_port_a
        movwf       porta
        movlw       d_port_b
        movwf       portb
        movlw       d_port_c
        movwf       portc
        movlw       d_intcon
        movwf       intcon
	movlw	    d_t1con
	movwf	    t1con
	clrf	pir1
	clrf	ccp1con
	clrf	ccp2con

	pagesel	famem
	call	famem		;holen der Init-Daten
	clrf	pclath
	clrf	flag	
anf1:        			;test ob Konfigurationsroutinen
	movlw	0fch		;sind nach RESET Tasten gedrckt
	xorwf	portb,w
	btfsc	status,z
	goto	reset		;RB0 und RB1 gedrckt, alle Variablen auf Standard
        btfss   e_cq1
        goto    cq1_con		;nach RESET RB-PIN Eingabe der Textschleife 1 
        btfss   e_cq2
        goto    cq2_con		;nach RESET RB-PIN Eingabe der Textschleife 2 
        btfss   e_mode
        goto    cq1_con		;nach RESET RB0 Eingabe der Textschleife 1
        btfss   e_start
        goto    config		;nach RESET RB0 Eingabe der Variablen
        goto    haupt

i2cerr:
	bsf	flag,nodisp	; kein Display angeschlossen
	goto	anf1

	nop			;Fehlerbehandlung nur zum Testen
        swapf	ercode,w
        call    mausg
        movf	ercode,w
        call    mausg
errstop:
	goto	errstop       

;=========================================================================
;Morsecodetabelle fuer die Ziffern
;=========================================================================

mtab:   addwf       pcl,f
        retlw       b'11111100'    ;0
        retlw       b'01111100'    ;1
        retlw       b'00111100'    ;2
        retlw       b'00011100'    ;3
        retlw       b'00001100'    ;4
        retlw       b'00000100'    ;5
        retlw       b'10000100'    ;6
        retlw       b'11000100'    ;7
        retlw       b'11100100'    ;8
        retlw       b'11110100'    ;9
        retlw       b'01100000'    ;A
        retlw       b'10001000'    ;B
        retlw       b'10101000'    ;C
        retlw       b'10010000'    ;D
        retlw       b'01000000'    ;E
        retlw       b'00101000'    ;F
;**************************************************************
; Tabelle  PWR 0 .. 8 Watt an 50 Ohm ... +/- 0,5W
;**************************************************************

tabpw	addwf	pcl,f
	retlw	0x00	; 0 ...00  --> 0,0 W
	retlw	0x00	; 1
	retlw	0x00	; 2
	retlw	0x00	; 3      
	retlw	0x01 	; 4
	retlw	0x02	; 5	 
	retlw	0x03 	; 6
	retlw	0x04	; 7
	retlw	0x05	; 8
	retlw	0x07	; 9	 
	retlw	0x08	;10 ...0A
	retlw	0x10	; B	 -->  1,0	
	retlw	0x12	; C
	retlw	0x14	; D	
	retlw	0x16	; E	 
	retlw	0x19	;15 ..0F  
	retlw	0x21	;16 ..10  --> 2,1
	retlw	0x24	;17
	retlw	0x27	;18
	retlw	0x30	;19      -->  3,0 W
	retlw	0x33 	;20      -->  3,3 W
	retlw	0x37	;21	 -->  3,7 W
	retlw	0x40 	;22
	retlw	0x44	;23
	retlw	0x48	;24
	retlw	0x52	;25	 -->  5,2 W
	retlw	0x56	;26 ...1A
	retlw	0x60	;27	 -->  6,0 W	
	retlw	0x65	;28
	retlw	0x70	;29	
	retlw	0x75	;30	 -->  7,5 W
	retlw	0x80	;31...1F -->  8,0 W
	retlw	80h


;=========================================================================
;Hauptprogramm
;=========================================================================

haupt:	
	call	starttext	;erste Morseausgabe
	pagesel	lcd_init
        call    lcd_init	;LCD Display abfragen, wenn da initialisieren
	clrf	pclath

	movlw	7fh		;da oberes Bit fr ZF +/- benutzt	
	andwf	cq_count,w	;Bakentest, wenn cq_count = 0 -> Bake
	btfss	status,z
	goto	hloop
	call	clear_buffer	;Anzeigepuffer lschen
	movlw	0c2h		;Anzeige Bake
	movwf	f_hf
	movlw	0c1h
	movwf	f_he
	movlw	0cbh
	movwf	f_hd
	movlw	0c5h
	movwf	f_hc
	call	anzeige		;Text Zeile1 und 2 ausgeben 
	goto	cq1_text

hloop:
	call	clear_buffer	;Anzeigepuffer lschen
	movlw	0c6h		;Anzeige F=
	movwf	f_hf
	movlw	0bdh
	movwf	f_he
	call	anzeige		;Text Zeile1 und 2 ausgeben 

;=========================================================================
;Tastenabfrageschleife
;=========================================================================

tloop:  
	comf    portb,w		;Status von Port B lesen und im Eingabepuffer halten
	bsf	intcon,rbie	; Int zulassen wenn RB4-7 wechseln also Paddle gedrueckt
	btfss	e_mode		;TA0 Menfunktionen
        goto    komm
        btfss   e_speed		;optionale Taste Tempoeinstellung
        call    speed
        btfss   e_cq1		;optionale Taste Text 1 ausgeben
        goto    cq1_text
        btfss   e_cq2		;optionale Taste Text 1 ausgeben
        goto    cq2_text
	goto	mess0		;Frequenz messen ohne Vorteiler
tloop2:
				;testen ob ZF Addition oder Subtraktion
	btfsc	cq_count,7
	goto	tloop0
	pagesel	addzf
	call	addzf		;ZF Ablage addieren
	clrf	pclath
	goto	tloop1
tloop0:	
	pagesel	subzf
	call	subzf 		;ZF Ablage subtrahieren
	clrf	pclath
tloop1:	call	dudez		;Dual-Dezimal-Wandlung
	pagesel	zeile2
	call	zeile2
	clrf	pclath
	btfss	e_start		;Morseausgabe der Frequenz
	call	frage

	btfsc	flag,fcq1
	goto	tloop3
	btfsc	flag,fcq2
	goto	tloop4

        goto    tloop

tloop3:
	decfsz	wtime
	goto	tloop
	goto	cq1_text

tloop4:
	decfsz	wtime
	goto	tloop
	goto	cq2_text


;=========================================================================
;Hauptmen T1-T2-U-S-P-F- Programmaufrufe
;=========================================================================
komm:	
	bcf	intcon,rbie	;kein Paddle-Int.
	movlw	b'11000000'
	call	zausg
	movlw	b'01111100'	;Kommando cq1
	call	zausg
	call	kom_cq1_txt
kcq1:	btfss	e_start
	goto	cq1_text
	btfsc	e_mode
	goto	kcq1

	movlw	b'11000000'
	call	zausg
	movlw	b'00111100'	;Kommando cq2
	call	zausg
	call	kom_cq2_txt
kcq2:	btfss	e_start
	goto	cq2_text
	btfsc	e_mode
	goto	kcq2

	movlw	b'00110000'	;Spannungsmessung
	call	zausg
	movlw	b'10001000'	
	call	zausg
uloop:	btfsc	e_dash		; TX ein ?
	goto	ulop1		; nein
	bsf	a_tx		; ja
	call	zen		; kurz warten dann HF ein
	bsf	a_tast		; #
	call	zen		; # zur Belastung der Batterie
	call	zen		; #
ulop1:	call	umess
	btfss	e_start
	call	u_morse_aus
	btfsc	e_mode
	goto	uloop
	bcf	a_tast		; Sender aus
	bcf	a_tx		; #


	movlw	b'00010000'	;SWR Messung
	call	zausg
	movlw	b'01110000'	
	call	zausg
	call	smess
sloop:	btfss	e_start
	call	swr_start
	btfsc	e_mode
	goto	sloop

	movlw	b'01101000'	;Power Messung
	call	zausg
	movlw	b'01010000'	
	call	zausg
	call	pmess
ploop:	btfss	e_start
	call	p_start
	btfsc	e_mode
	goto	ploop

floop:	movlw	b'00101000'	;Frequenzmessung
	call	zausg
	movlw	b'01100000'	
	call	zausg
	goto	hloop
	
;=========================================================================
;Tasten TX ein; Teil der ISR 
;=========================================================================
mtast:
	bcf	intcon,rbie	;Int enble loeschen
	bcf	intcon,rbif	;Int Flag loeschen
        btfss   e_dot		;Taste gedrckt Strich/punkt ?
        goto    send_p
        btfss   e_dash
        goto    send_s
	btfss	e_handtaste	;Handtaste ?
	goto	hand
	goto	iend		;Ende der ISR

send_p:	
	bsf	a_tx		;U.TX ein
	call	punkt
        goto    mtast0
send_s:
	bsf	a_tx		;U.TX ein
	call	strich

mtast0:
	bcf	flag,fcq1	;Wiederholung cq1 Schleife lschen 
	bcf	flag,fcq2	;Wiederholung cq2 Schleife lschen 
        btfss       e_dash
lstr:   call        strich
        bcf         eing,7
        btfsc       eing,6
        goto        los
        btfss       e_dot
lpkt:   call        punkt
        bcf         eing,6
        btfsc       eing,7
        goto        lop
	btfss	e_start		;Tempo beim Senden
	goto	sspeed
	decfsz	txlo,f		;RX->TX Delay 16 bit Zaehler
	goto	mtast0		; .. runter auf Null 
	decfsz	txhi,f
	goto	mtast0
	bcf	a_tx		;U.RX
	movf	portb,w		;Port B Status lesen
	bcf	intcon,rbif	;eventuelle Int. anfragen loeschen
	goto	iend		;Ende der ISR

los:    clrf        eing	;Punktspeicher
        goto        lpkt

lop:    clrf        eing	;Strichspeicher
        goto        lstr

sspeed:				;Speed im Sendemodus setzen
	bcf	a_tx		;Sender aus
	call        punkt
        movlw       1
        btfss       e_dash
        addwf       tempo,f	;Tempo +
        btfss       e_dot
        subwf       tempo,f	;Tempo -
        btfss       e_start
        goto        sspeed
        clrf        eing
	pagesel	femem
	call	    femem	;Speichern im EEPROM
	clrf	pclath
	bsf	a_tx		;Sender ein und weiter im QSO
        goto	mtast0

;=========================================================================
;Morsetempo einstellen und abspeichen in EEPROM
;=========================================================================

speed:				;allgemeine Speedeinstellung
	bcf	intcon,rbie	;kein Paddle-Int. also jeden weiteren INT. 
				;.. sperren
	call        punkt
        movlw       1
        btfss       e_dash
        addwf       tempo,f	;Tempo +
        btfss       e_dot
        subwf       tempo,f	;Tempo -
        btfss       e_speed
        goto        speed
        clrf        eing
	pagesel	femem
	call	    femem	;Speichern im EEPROM
	clrf	pclath
        return


;=========================================================================
;Spannungsmessung
;=========================================================================

umess:
	movlw	0x41     	; anal. kanal RA0
	movwf	adcon0		; ... als Messeingang setzen
	call	zem		;kurz warten
	bsf	adcon0,2	;Start Messung
ubme1:	btfsc	adcon0,2	;warten bis Messung beendet
	goto	ubme1   	;Ergebnis in adresh und adresl
	call	clear_buffer	;Anzeigespeicher loeschen
	movf	adresh,w	;nur die oberen 8 Bit werden genutzt
	call	bin_bcd		;Umwandlung in eine 3 stellige BCD Zahl
				; incl. Dezimalpunkt in Zeile 2
	movlw	0d5h		;Zeile 1 'Ub='
	movwf	f_hf
	movlw	0e2h
	movwf	f_he
	movlw	0bdh
	movwf	f_hd
	call	anzeige		;Anzeige
	return

		

u_morse_aus:			; 2 oder 3 Ziffern incl. Punkt
	bcf	a_tast		; Sender aus
	bcf	a_tx		; #
        movf	f_h3,w
	andlw	0fh		;fhrende Null wird nicht ausgegeben
	btfss	status,z
        call	mausg
        movf	f_h2,w
        call	mausg
	movlw	b'01010110'	;Punkt
	call	zausg
        movf	f_h0,w
        call	mausg
	
	return

;=========================================================================
;SWR Messung
;=========================================================================

smess:				;Textausgabe frs Men
	call	clear_buffer
	movlw	0d3h
	movwf	f_hf
	movlw	0d7h
	movwf	f_he
	movlw	0d2h
	movwf	f_hd
	movlw	0bdh
	movwf	f_hc
	call	anzeige
	return

swr_start:
	movlw	b'01010110'
	call	zausg
	bsf	a_tx
	bsf	a_tast

	movlw	0ffh		;timer 1 High Wert Standardwert
	movwf	tmr1h
	movlw	080h		;timer 1 High Wert Standardwert
	movwf	tmr1l
	movwf	swrton		;Grundton
	movlw	1		;Standartwert Tonwechsel
	movwf	tw0
	movwf	tw1
	bsf	flag,tonw	;Tonwechsel Flag
	bsf	intcon,6	;Int Global und Pi an, Ton laeuft

swr_loop:
	movlw	0x49     	;Analog AN1  SWR Rcklauf
	movwf	adcon0
	call	zem
	bsf	adcon0,2
swme1	btfsc	adcon0,2
	goto	swme1   	; ergebnis in adresh und adresl
	movf	adresh,w
	movwf	swr_r

	movlw	0x59    	;Analog AN3 SWR Vorlauf 
	movwf	adcon0
	call	zem
	bsf	adcon0,2
swme2	btfsc	adcon0,2
	goto	swme2   	; ergebnis in adresh und adresl
	movf	adresh,w
	movwf	swr_v

	movf	swr_v,w		;u vor + u ret
	addwf	swr_r,w
	movwf	temp
	movf	status,w
	andlw	01h
	movwf	temp1
	movf	swr_r,w		;u vor - u ret
	subwf	swr_v,w
	movwf	temp2
				;der Zaehler Uvor+Uret wird mit 80
				;multipliziert, da keine Gleitkommarechnung
				; -> groessere Aufloesung
 
	rlf	temp,f		;Multiplikation mit 2
	rlf	temp1,f
	bcf	temp,0
	movf	temp,w
	movwf	mem		;retten des Doppelten
	movf	temp1,w
	movwf	z_anz		;retten auch des high Teils
	rlf	temp,f		;Multiplikation mit 4
	rlf	temp1,f
	bcf	temp,0
	rlf	temp,f		;Multiplikation mit 8
	rlf	temp1,f
	bcf	temp,0
	movf	mem,w		;das Achtfache + das Doppelte = Zehnfache
	addwf	temp,f
	btfsc	status,c
	incf	temp1,f
	movf	z_anz,w
	addwf	temp1,f
	rlf	temp,f		;Multiplikation mit 2 = Zwanzigfache
	rlf	temp1,f
	bcf	temp,0
	rlf	temp,f		;Multiplikation mit 2 = Vierzigfache
	rlf	temp1,f
	bcf	temp,0
	rlf	temp,f		;Multiplikation mit 2 = Achtzigfache
	rlf	temp1,f
	bcf	temp,0

div_swr:			;u vor / u ret
	movlw	10h             ;16 Bitlnge 		
	movwf	mem
	clrf	z_a
	bcf	status,0
div_swr0:
	rlf	temp,f
	rlf	temp1,f
	rlf	z_a,f
	btfsc	status,c
	goto	div_swr2
	movf	temp2,w
	subwf	z_a,w
	btfss	status,0
	goto	div_swr1
div_swr2:
	movf	temp2,w
	subwf	z_a,f
	bsf	status,c
div_swr1:
	decfsz	mem,f
	goto	div_swr0
	rlf	temp,f
	rlf	temp1,f
	rlf	z_a,f

	movf	temp1,w
	btfss	status,z
	goto	swr_0		;SWR grer 3,1

	movf	temp,w		;nein
	movwf	z_a
	movlw	14h		; Tonbereich einstellen
	subwf	z_a,w		;
	movwf	swrton
	goto	swr_1		; zur Anzeige

swr_0:	bcf	status,c	;SWR > 3,1 Tonwechselfrequenz
	rlf	temp,w		; ... berechnen
	movwf	tw2
	rlf	temp1,f
	movf	temp1,w
	andlw	0f0h
	btfss	status,z
	goto	swr_4
	movf	temp1,w
	movwf	tw3		
	goto	swr_5
swr_4:	movlw	0fh
	movwf	temp1
swr_5:	movlw	0f8h		;konstanter Ton bei groen SWR
	movwf	swrton

swr_1:				;SWR durch 8 teilen, es bleibt 10*SWR
	bcf	status,c	; :2
	rrf	temp1,f
	rrf	temp,f
	bcf	status,c	; :2
	rrf	temp1,f
	rrf	temp,f
	bcf	status,c	; :2
	rrf	temp1,f
	rrf	temp,f
	movf	temp1,f
	btfss	status,z
	goto	swr_2
	movf	temp,w
	goto	swr_3
swr_2:	movlw	0ffh
swr_3:	call	bin_bcd		;umwandlung von 10*SWR in 3 stellige BCD Zahl
				; ... mit einer Stelle hinterm Komma
	pagesel	zeile2
	call	zeile2		; Anzeige
	clrf	pclath
swr_end:
	btfsc	e_start
	goto	swr_loop
	bcf	intcon,6	;Int Perepherie aus damit Ton aus
	bcf	a_tx		;Sender aus
	bcf	a_tast		; Taste aus
	call	u_morse_aus	;Morseausgabe
	return


;=========================================================================
;Power Messung
;=========================================================================
pmess:				;Textausgabe frs Men
	call	clear_buffer
	movlw	0d0h
	movwf	f_hf
	movlw	0d7h
	movwf	f_he
	movlw	0d2h
	movwf	f_hd
	movlw	0bdh
	movwf	f_hc
	call	anzeige
	return

p_start:
	movlw	b'01010110'
	call	zausg
	bsf	a_tx
	bsf	a_tast
p_loop:
	movlw	0x59     	;
	movwf	adcon0
	call	zem
	bsf	adcon0,2
pme1	btfsc	adcon0,2
	goto	pme1   		; ergebnis in adresh und adresl
	movf	adresh,w
	movwf	temp
	rrf	temp,f
	rrf	temp,f
	rrf	temp,w		; 3 low-nibble Bits rausschieben
	andlw	1fh		; 3 bit vom high-nibble ausmaskieren
	call	tabpw		; Auswertung nur von 0 - 1F(hex)
	movwf	temp		; 32 PWR-Werte ... 2stellig
	swapf	temp,w
	andlw	0fh
	movwf	f_h2
	movf	temp,w
	andlw	0fh
	movwf	f_h0
	movlw	0aeh
	movwf	f_h1
	pagesel	zeile2
	call	zeile2
	clrf	pclath
p_end:
	btfsc	e_start
	goto	p_loop
	bcf	a_tx
	bcf	a_tast
	call	u_morse_aus
	return

;=========================================================================
;cq Text ausgeben
;=========================================================================
kom_cq1_txt:			;Textausgabe frs Men
	call	clear_buffer
	movlw	0c3h
	movwf	f_hf
	movlw	0d1h
	movwf	f_he
	movlw	01h
	movwf	f_hd
	call	anzeige
	return
kom_cq2_txt:			;Textausgabe frs Men
	call	clear_buffer
	movlw	0c3h
	movwf	f_hf
	movlw	0d1h
	movwf	f_he
	movlw	02h
	movwf	f_hd
	call	anzeige
	return

cq1_text:
	bcf	intcon,rbie	;kein Paddle-Int.
	bsf	a_tx
	clrf        eing
	movf	    cq_count,w	;Anzahl der Wiederholungen
	andlw	0fh		;nur unteres Nibble, max. 15 Durchlufe
	movwf       zaehler
	movlw	070h
	andwf	cq_count,w	;Wartezeit  nur Bit 4,5,6
	btfss	status,z
	bsf	flag,fcq1
	bcf	flag,fcq2
	addlw	20h
	movwf	wtime
	
	
cq20:   movlw       speicher1-1
        movwf       z_anz	;Zeiger auf aktuellen Buchstaben 
	goto	    cq1
	
cq2_text:
	bcf	intcon,rbie	;kein Paddle-Int.
	bsf	a_tx
	clrf        eing
	movf	    cq_count,w	;Anzahl der Wiederholungen
	andlw	0fh		;nur unteres Nibble, max. 15 Durchlufe
	movwf       zaehler
	movlw	070h
	andwf	cq_count,w	;Wartezeit  nur Bit 4,5,6
	btfss	status,z
	bsf	flag,fcq2
	bcf	flag,fcq1
	addlw	20h
	movwf	wtime
cq10:   movlw       speicher2-1
        movwf       z_anz	;Zeiger auf aktuellen Buchstaben

cq1:    
	incf        z_anz,f	;Zeiger auf Buchstaben setzen
        movf        z_anz,w
	banksel	    bank2
	movwf	    eeadr	;Zeiger in EE Adresse
	banksel     bank3
	bcf	    eecon1,eepgd
	bsf	    eecon1,rd
	banksel	    bank2
	movf	    eedata,w	;EEPROM lesen
	banksel     bank0
        movwf       z_mem	;aktueller Buchstabe
        movf        z_mem,f
        btfsc       status,2     ;zelle mit 0?
        goto        cq2		;Wortpause
        movlw       0ffh
        subwf       z_mem,w
        btfsc       status,2
        goto        cq3
        movf        z_mem,w
        call        zausg	;Zeichenausgabe
        goto        cq1


cq2:    call        wpause
        goto        cq1

cq3:    btfsc       eing,6	;vorzeitiger Abbruch wenn Paddle angetippt
        goto        cq_abbruch
        btfsc       eing,7	;vorzeitiger Abbruch wenn Paddle angetippt
        goto        cq_abbruch
	decfsz	    zaehler,f
	goto	    cq4   
	movlw	0fh		;da oberen Bits fr ZF +/- und wdh benutzt	
	andwf	cq_count,w	;Bakentest, wenn cq_count = 0 -> Bake
	btfsc	status,z
	goto	cq20

cqend:  movlw       b'01101000'    	;p  end of call "pse k"
        call        zausg
        movlw       b'00010000'    	;s
        call        zausg
        movlw       b'01000000'    	;e
        call        zausg
        call        wpause
        movlw       b'10110000'    	;k
        call        zausg
        clrf        eing
	bcf	a_tx
        goto	    hloop

cq4:	movf	    z_anz,w	;Ende welches Speichers erreicht

;********************************
	if ptype == 876
;********************************
	andlw	    80h		;oberes Bit trennt die Speicherbereiche 
;********************************
	else
;********************************
	andlw	    40h		;nur halber Speicher da 
;********************************
	endif
;********************************

	btfss	    status,z
	goto	    cq10
        goto        cq20

cq_abbruch:
	bcf	flag,fcq1
	bcf	flag,fcq2
        clrf    eing
	bcf	a_tx
        goto	hloop

;=========================================================================
;Messwertausgabe an die I2C-Anzeige
;=========================================================================

anzeige:
	pagesel	zeile1
        call    zeile1
	clrf	pclath
	pagesel	zeile2
        call    zeile2
	clrf	pclath
	return

clear_buffer:
	movlw	0a0h
	movwf	f_h0		
	movwf	f_h1		
	movwf	f_h2		
	movwf	f_h3		
	movwf	f_h4		
	movwf	f_h5		
	movwf	f_h6		
	movwf	f_h7		
	movwf	f_h8
	movwf	f_h9
	movwf	f_ha
	movwf	f_hb
	movwf	f_hc
	movwf	f_hd
	movwf	f_he
	movwf	f_hf
	return
;=========================================================================
;Frequenzmessroutinen
;=========================================================================
mess0:				;kein Vorteiler
	clrf	tmr0
	clrf	z_b2	
	bcf	intcon,2
	movlw	00h
	movwf	porta

	movlw	fmessin		; RA4 Eingang wird Frequenzzaehlereingang
	banksel bank1		; Registerbank 80h..0AFh
	movwf	trisa		; port RA4 wird Eingang
	banksel bank0		; Registerbank 0..2FH
	call	d100ms		; ohne Vorteiler
	movlw	fmessout	; RA4 Ausgang stopt Frequenzzaehler
	banksel bank1		; Registerbank 80h..0AFh
	movwf	trisa		; port RA4 wird Ausgang mit low Pegel
	banksel bank0		; Registerbank 0..2FH

mess4:	btfsc	intcon,2	;noch ein berlauf da?
	incf	z_b2,f
	bcf	intcon,2
	movf	tmr0,w
	movwf	z_b1
	clrf	z_b0		; auslesen des Prescalers
mess5:	incf	z_b0,f
        banksel	bank1		; Registerbank 1
	bsf	option_reg,4	;Impuls am Vorteilereingang	
	bcf	option_reg,4
        banksel	bank0		; Registerbank 0
	movf	tmr0,w
	subwf	z_b1,w
	skpnz
	goto	mess5
	comf	z_b0,f
	incf	z_b0,f
	goto	tloop2

;=========================================================================
;diverse Zeitschleifen Verzoegerungszeiten (gelten fuer 4.000 MHz)
;=========================================================================

d100ms:	movlw	0ah             ;10		;mit call 99995 Zyklen lang 99,995ms 
	movwf	temp
d100ms1:call	d10ms
;	nop
	decfsz	temp,f
	goto	d100ms1
	return	

d10ms:	movlw	0ah             ;10		;mit call 9996 Zyklen lang 9,996ms 
	movwf	temp1
	nop
d10ms0:	call	d1ms
	decfsz	temp1,f
	goto	d10ms0
	return

d1ms:	movlw   6eh             ;110		;mit call 996 Zyklen lang 0,996ms 
        movwf   temp2
	nop
d1ms1:	btfss	intcon,2
	goto	d1ms2
	incf	z_b2,f
	bcf	intcon,2
	goto	d1ms3
d1ms2:	nop
	nop
	nop
d1ms3:	decfsz	temp2,f
	goto	d1ms1
	return 

;*******************************************************
;  Zeitschleife 26us ... aquisition-time des ADU
;*******************************************************
zem	movlw	0x07   ; zeitschleife 26 us  
	movwf	temp
zem1	decfsz	temp,f
	goto	zem1
	return
;*******************************************************
;  Zeitschleife 196,1 ms ( zur beliebigen Verwendung )
;*******************************************************
zen	movlw	0xff   ; zeitschleife 196,1 ms
	movwf	temp
zen1	movlw	0xff
	movwf	temp1
zen2	decfsz	temp1,f
	goto	zen2
	decfsz	temp,f
	goto	zen1
	return


;=========================================================================
;Dual-Dezimal-Konvertierung 
;24 bit Dualzahl z_b0....z_b2 wird in die eine 8 stellige Dezimalzahl 
;gewandelt. (BCD-Format in f_h0...f_h7)
;=========================================================================
dudez:	
	call	clear_buffer
	call	div10
	movwf	f_h0
	call	div10
	movwf	f_h1
	movlw	0aeh
	movwf	f_h2
	call	div10
	movwf	f_h3
	call	div10
	movwf	f_h4
	call	div10
	movwf	f_h5
	call	div10
	movwf	f_h6
	call	div10
	movwf	f_h7
	call	div10
;	movwf	f_h8
	bcf	flag,fnull
	movf	f_h8,w
	call	vnull
	movwf	f_h8
	movf	f_h7,w
	call	vnull
	movwf	f_h7
	movf	f_h6,w
	call	vnull
	movwf	f_h6
	movf	f_h5,w
	call	vnull
	movwf	f_h5
	movf	f_h4,w
	call	vnull
	movwf	f_h4
	return
vnull:				;fhrende Null als Space anzeigen
	andlw	0fh
	btfss	status,z
	bsf	flag,fnull	;flag setzen wenn eine Ziffer <>0
	btfss	flag,fnull
	movlw	0a0h
	return
		
div10:				;division der Dualzahl durch 10
	movlw	18h             ;24		; der Rest steht im w-Register
	movwf	temp
	clrf	z_a
	bcf	status,0
div100:	rlf	z_b0,f
	rlf	z_b1,f
	rlf	z_b2,f
	rlf	z_a,f
	movlw	0ah
	subwf	z_a,w
	btfss	status,0
	goto	div101
	movlw	0ah
	subwf	z_a,f
div101:	decfsz	temp,f
	goto	div100
	rlf	z_b0,f
	rlf	z_b1,f
	rlf	z_b2,f
	rlf	z_a,f
	rrf	z_a,w
	return

;=========================================================================
;Dual-Dezimal-Konvertierung 
;8 bit Dualzahl Register w wird in die eine 3 stellige Dezimalzahl 
;gewandelt. (BCD-Format in f_h0...f_h2)
;=========================================================================

bin_bcd:	
            
	movwf	temp
	clrf	f_h3
	clrf	f_h2
	clrf	f_h0
	
hu	movlw	0x64      ; 100
	subwf	temp,f	
	btfsc	status,0  ; carry
	goto	hu1
	goto	ze
hu1	incf	f_h3,f
	goto	hu
ze	movlw	0x64
	addwf	temp,f
ze1	movlw	0x0a
	subwf	temp,f
	btfsc	status,0
	goto	ze2
	goto	ei1
ze2	incf	f_h2,f
	goto	ze1
ei1	movlw	0x0a
	addwf	temp,f
	movf	temp,w
	movwf	f_h0
	movlw	0aeh
	movwf	f_h1
	movlw	0a0h		;fhrende Null in der Anzeige lschen
	movf	f_h3,f
	btfsc	status,z
	movwf	f_h3
	return		


;=========================================================================
;Morseausgabe der Frequenz
;=========================================================================
starttext:
        clrf    eing
        movf	call1,w        
        call    zausg
        movf	call2,w        
        call    zausg
        movf	call3,w        
        call    zausg
        movf	call4,w        
        call    zausg
        movf	call5,w        
        call    zausg
        movf	call6,w        
        call    zausg
	return

frage:  
	bcf	intcon,rbie	;kein Paddle-Int.
        movf	f_h7,w		;Zehner MHz
	btfsc	fmask,7
        call	mausg
        movf	f_h6,w		;Einer MHz
	btfsc	fmask,6
        call	mausg
        movf	f_h5,w		;Hunderter kHz
	btfsc	fmask,5
        call	mausg
        movf	f_h4,w		;Zehner kHz
	btfsc	fmask,4
        call	mausg
        movf	f_h3,w		;Einer kHz
	btfsc	fmask,3
        call	mausg
        movf	f_h1,w		;Hunderter Hz
	btfsc	fmask,2
        call	mausg
        movf	f_h0,w		;Zehner Hz
	btfsc	fmask,1
        call	mausg
        return

mausg:  andlw       0fh
        call        mtab
        call        zausg
        return

zausg:  movwf       z_mem
;********************************
	if	lcdtype == 1
;********************************
	bsf	    a_rx_mute
;********************************
	else
;********************************
	nop
;********************************
	endif
;********************************

mloop:  bcf         status,0
        rlf         z_mem,f
        movf        z_mem,f
        btfsc       status,2
        goto        rol4
        btfsc       status,0
        goto        mstr
        call        punkt
        goto        mloop
mstr:   call        strich
        goto        mloop

rol4:   call        zpause
;********************************
	if	lcdtype == 1
;********************************
	bsf	    a_rx_mute
;********************************
	else
;********************************
	nop
;********************************
	endif
;********************************
        return

;=========================================================================
;Morsezeichen erzeugen
;=========================================================================

punkt:  
	clrf	txlo
	movf	txhi_mem,w		;Zeitverzoegerung
	movwf	txhi
	movf        ton,w              ;Tonhhe laden
        movwf       freq
        movf        tempo,w
        movwf       duratn
        movf	tastv,w
	andlw	0fh
        movwf       drei
	btfsc	    a_tx		;HF Tastung nur bei TX ein
        bsf         a_tast
        call        beep
        bcf         a_tast
        clrf        freq
	movlw	    01h
        movwf       drei
        call        beep
        return

strich: 
	clrf	txlo
	movf	txhi_mem,w		;Zeitverzoegerung
	movwf	txhi
	movf        ton,w              	;Tonhhe laden
        movwf       freq
        movf        tempo,w
        movwf       duratn
        swapf   tastv,w
	andlw	0fh
        movwf       drei
	btfsc	    a_tx		;HF Tastung nur bei TX ein
        bsf         a_tast
        call        beep
        bcf         a_tast
        clrf        freq
        movf        tempo,w
        movwf       duratn
	movlw	    01h
        movwf       drei
        call        beep
        return

wpause: 
        swapf	pausev,w
	andlw	0fh
        goto        pause
zpause:      
        movf	pausev,w
	andlw	0fh
        goto        pause
ppause: 
        movf	tastv,w
	andlw	0fh
pause:  movwf       drei
        clrf        freq
        movf        tempo,w
        movwf       duratn
        call        beep
        return

;=========================================================================
;Zeitschleife mit Tonausgabe
;=========================================================================
beep:   movlw       tonport
        movwf       t_pat
        movf        freq,w
        movwf       f_temp
        movf        freq,f
        btfss       status,2
        goto        cont
        clrf        t_pat
cont:   movf        t_pat,w
        movwf       tgl
cont1:  movf        duratn,w
        movwf       d_hi
        movlw       00fh
        movwf       d_lo
main:   movf        tgl,w
        xorwf       porta,f
        movlw       0ffh
        xorwf       portb,w
        iorwf       eing,f
delay:  decfsz      f_temp,f
        goto        rol1
        movf        freq,w
        movwf       f_temp
        movf        t_pat,w
        movwf       tgl
dloop:  decfsz      d_lo,f
        goto        rol2
        movlw       00fh
        movwf       d_lo
        decfsz      d_hi,f
        goto        main
        goto        rol3

rol1:   clrf        tgl
        goto        dloop
rol2:   nop
        nop
        nop
        nop
        nop
        goto        main
rol3:   decfsz      drei,f
        goto        cont1
        return

;=========================================================================
; Tongenerator durch Handtaste gestartet, Teil der ISR
;=========================================================================

hand:	bsf	a_tx
	movf        ton,w              	;Tonhhe laden
        movwf       freq
	movlw       tonport
        movwf       t_pat
        movf        freq,w
        movwf       f_temp
        movf        freq,f
hand0:  
	bsf	a_tast
	movf        t_pat,w
        movwf       tgl
hand1:  nop
	nop
	nop
	nop
handm:	movf        tgl,w
        xorwf       porta,f
	nop
	nop
	nop
handd:  decfsz      f_temp,f
        goto        hand3
        movf        freq,w
        movwf       f_temp
        movf        t_pat,w
        movwf       tgl
hand2:  nop
        nop
        nop
        nop
        nop
handx:    
        btfss       e_handtaste
        goto        hand1
        bcf         a_tast
	decfsz	txlo,f		;RX->TX Delay
	goto	handx
	decfsz	txhi,f
	goto	handx
	bcf	a_tx		;U.RX
        goto    iend

hand3:  clrf        tgl
        goto        hand2



;=========================================================================
;Kommando im Morsecode wird erwartet
;alle Zeichen <8 gltig
;=========================================================================
fin:    movlw       01h          ;warten auf morsezeichen
        movwf       sr0
fin1:   btfss       e_dash
        goto        ls
        btfss       e_dot
        goto        lp
        btfss       e_start
        goto        fin6
        goto        fin1

fin2:	movf	tempo,w
	movwf	d_hi   
	rrf	d_hi,f
	rrf	d_hi,w
	andlw	3fh
	movwf	d_hi
fin2x:
	btfss       e_dash
        goto        ls
        btfss       e_dot
        goto        lp
	decfsz	txlo,f		;256 * Tempo/4 -> Verzgerung	
	goto	fin2x		; ..etwa 2*Punktlaenge
	decfsz	d_hi,f
	goto	fin2x

	clrf	cf
	movf	sr0,f		;testen ob alles punkte waren
	btfsc	status,z
	goto	fin7
	bsf         status,0     ;zeichen empfangen und ausrichten
        rlf         sr0,f
fin3:   btfsc       status,0
        goto        fin4
        rlf         sr0,f
        goto        fin3
fin4:   nop
fin5:   clrf        eing
        movf        sr0,w
        return


fin6:	
        movlw       b'01000000'    	;s
        call        zausg
        clrf        eing
        movf        eing,w
        return

fin7:	movlw	01h
	clrf	eing
	return

ls:     call        strich
        bsf         status,0
        rlf         sr0,f
        bcf         eing,7
        btfsc       eing,6
        goto        ls1
        btfss       e_dash
        goto        ls
        goto        fin2
lp:     call        punkt
        bcf         status,0
        rlf         sr0,f
        bcf         eing,6
        btfsc       eing,7
        goto        lp1
        btfss       e_dot
        goto        lp
        goto        fin2

ls1:    clrf        eing
        goto        lp
lp1:    clrf        eing
        goto        ls

;=========================================================================
;Konfiguration der Taste Menue
;=========================================================================
cq2_con:
	pagesel	lcd_init
        call    lcd_init
	clrf	pclath
	call	wpause
	goto	cq2_config

cq1_con:
	pagesel	lcd_init
        call    lcd_init
	clrf	pclath
	call	wpause
        clrf    eing
        movlw	b'11000000'	;t        
        call    zausg
        movlw	b'01000000'	;e       
        call    zausg
        movlw	b'10011000'	;x       
        call    zausg

cq1_config:
	movlw	b'11000000'	;Kommando Texteingabe
	call	zausg
	movlw	b'01111100'	;1
	call	zausg
	call	kom_cqtxt1
ktxt1:	btfss	e_start
	goto	cq1_input
	btfsc	e_mode
	goto	ktxt1

cq2_config:
	movlw	b'11000000'	;Kommando Texteingabe
	call	zausg
	movlw	b'00111100'	;2
	call	zausg
	call	kom_cqtxt2
ktxt2:	btfss	e_start
	goto	cq2_input
	btfsc	e_mode
	goto	ktxt2

	goto	cq1_config

config:
	pagesel	lcd_init
        call    lcd_init
	clrf	pclath
        clrf    eing
        movlw	b'10101000'	;c        
        call    zausg
        movlw	b'11110000'	;o       
        call    zausg
        movlw	b'10100000'	;n       
        call    zausg
        movlw	b'00101000'	;f       
        call    zausg
        movlw	b'00100000'	;i       
        call    zausg
        movlw	b'11010000'	;g       
        call    zausg
	call	wpause

menu_input:

	movlw	b'00010000'
	call	zausg
	movlw	b'10010000'	;Kommando Speed
	call	zausg
	call	kom_speed
ksloop:	btfss	e_start
	goto	k_speed
	btfsc	e_mode
	goto	ksloop


	movlw	b'11000000'
	call	zausg
	movlw	b'00001000'	;Kommando Hoehe
	call	zausg
	call	kom_ton
khloop:	btfss	e_start
	goto	k_ton
	btfsc	e_mode
	goto	khloop

	movlw	b'11001000'	;Kommando ZF ADD/SUBB
	call	zausg
	movlw	b'00101000'	;
	call	zausg
kzf:	call	kom_zf
	btfss	e_start
	goto	zf_change
	btfsc	e_mode
	goto	kzf

	movlw	b'11001000'	;Kommando ZF-Eingabe
	call	zausg
	movlw	b'00100000'	;
	call	zausg
	call	kom_zf_in
k_zf_in:
	btfss	e_start
	goto	zf_input
	btfsc	e_mode
	goto	k_zf_in

	movlw	b'10010000'	;Kommando Delay-Eingabe
	call	zausg
	movlw	b'01000000'	;
	call	zausg
	call	kom_delay_in
k_dl_in:
	btfss	e_start
	goto	delay_input
	btfsc	e_mode
	goto	k_dl_in

	movlw	b'11000000'	;Kommando Tastverhaeltnis-Eingabe
	call	zausg
	movlw	b'00011000'	;
	call	zausg
	call	kom_tastv_in
k_tv_in:
	btfss	e_start
	goto	tastv_input
	btfsc	e_mode
	goto	k_tv_in

	movlw	b'01101000'	;Kommando Pausenverhaeltnis-Eingabe
	call	zausg
	movlw	b'00011000'	;
	call	zausg
	call	kom_pausev_in
k_pv_in:
	btfss	e_start
	goto	pausev_input
	btfsc	e_mode
	goto	k_pv_in

	movlw	b'10101000'	;Kommando Starttext
	call	zausg
	movlw	b'01001000'	;
	call	zausg
	call	kom_call_in
k_cl_in:
	btfss	e_start
	goto	call_input
	btfsc	e_mode
	goto	k_cl_in

	movlw	b'00101000'	;Kommando Freqenzmaske
	call	zausg
	movlw	b'11100000'	;
	call	zausg
	call	kom_freq_in
k_fm_in:
	btfss	e_start
	goto	freq_input
	btfsc	e_mode
	goto	k_fm_in

	movlw	b'10101000'	;Kommando cqza
	call	zausg
	movlw	b'11011000'	;
	call	zausg
	call	kom_cqza_in
k_ca_in:
	btfss	e_start
	goto	cqza_input
	btfsc	e_mode
	goto	k_ca_in

	movlw	b'01110000'	;Kommando Wartezeit
	call	zausg
	movlw	b'11001000'	;
	call	zausg
	call	kom_wz_in
k_wz_in:
	btfss	e_start
	goto	wz_input
	btfsc	e_mode
	goto	k_wz_in

	goto	menu_input

reset:
	pagesel	lcd_init
        call    lcd_init
	clrf	pclath
	call	kom_reset_in
	pagesel	reset_input
	call	reset_input
	clrf	pclath
        clrf    eing
        movlw	b'01010000'	;r        
        call    zausg
        movlw	b'01000000'	;e       
        call    zausg
        movlw	b'00010000'	;s       
        call    zausg
        movlw	b'01000000'	;e       
        call    zausg
        movlw	b'11000000'	;t       
        call    zausg
	call	wpause
	goto	haupt


;=========================================================================
;Konfiguration der Taste Bilder im Display
;=========================================================================
kom_speed:
	call	clear_buffer
	movlw	0d3h
	movwf	f_hf
	movlw	0d0h
	movwf	f_he
	movlw	0c5h
	movwf	f_hd
	movlw	0c5h
	movwf	f_hc
	movlw	0c4h
	movwf	f_hb
	call	anzeige
	return
kom_ton:
	call	clear_buffer
	movlw	0d4h
	movwf	f_hf
	movlw	0cfh
	movwf	f_he
	movlw	0ceh
	movwf	f_hd
	call	anzeige
	return


kom_cqtxt1:
	call	clear_buffer
	movlw	0d4h
	movwf	f_hf
	movlw	0c5h
	movwf	f_he
	movlw	0d8h
	movwf	f_hd
	movlw	0d4h
	movwf	f_hc
	movlw	0a0h
	movwf	f_hb
	movlw	01h
	movwf	f_ha
	call	anzeige
	return
kom_cqtxt2:
	call	clear_buffer
	movlw	0d4h
	movwf	f_hf
	movlw	0c5h
	movwf	f_he
	movlw	0d8h
	movwf	f_hd
	movlw	0d4h
	movwf	f_hc
	movlw	0a0h
	movwf	f_hb
	movlw	02h
	movwf	f_ha
	call	anzeige
	return
kom_menu:
	call	clear_buffer
	movlw	0c3h
	movwf	f_hf
	movlw	0cfh
	movwf	f_he
	movlw	0ceh
	movwf	f_hd
	movlw	0c6h
	movwf	f_hc
	movlw	0c9h
	movwf	f_hb
	movlw	0c7h
	movwf	f_ha
	call	anzeige
	return
kom_zf:
	call	clear_buffer
	movlw	0dah
	movwf	f_hf
	movlw	0c6h
	movwf	f_he
	btfss	cq_count,7
	movlw	0abh
	btfsc	cq_count,7
	movlw	0adh
	movwf	f_hd
	call	anzeige
	return
kom_zf_in:
	call	clear_buffer
	movlw	0dah
	movwf	f_hf
	movlw	0c6h
	movwf	f_he
	movlw	0a0h
	movwf	f_hd
	movlw	0c9h
	movwf	f_hc
	movlw	0ceh
	movwf	f_hb
	call	anzeige
	return
kom_delay_in:
	call	clear_buffer
	movlw	0c4h
	movwf	f_hf
	movlw	0c5h
	movwf	f_he
	movlw	0cch
	movwf	f_hd
	movlw	0c1h
	movwf	f_hc
	movlw	0d9h
	movwf	f_hb
	call	anzeige
	return
kom_tastv_in:
	call	clear_buffer
	movlw	0d4h
	movwf	f_hf
	movlw	0c1h
	movwf	f_he
	movlw	0d3h
	movwf	f_hd
	movlw	0d4h
	movwf	f_hc
	movlw	0d6h
	movwf	f_hb
	call	anzeige
	return
kom_pausev_in:
	call	clear_buffer
	movlw	0d0h
	movwf	f_hf
	movlw	0c1h
	movwf	f_he
	movlw	0d5h
	movwf	f_hd
	movlw	0d3h
	movwf	f_hc
	movlw	0c5h
	movwf	f_hb
	call	anzeige
	return
kom_call_in:
	call	clear_buffer
	movlw	0c3h
	movwf	f_hf
	movlw	0c1h
	movwf	f_he
	movlw	0cch
	movwf	f_hd
	movlw	0cch
	movwf	f_hc
	call	anzeige
	return
kom_freq_in:
	call	clear_buffer
	movlw	0c6h
	movwf	f_hf
	movlw	0adh
	movwf	f_he
	movlw	0cdh
	movwf	f_hd
	movlw	0c1h
	movwf	f_hc
	movlw	0d3h
	movwf	f_hb
	movlw	0cbh
	movwf	f_ha
	movlw	0c5h
	movwf	f_h9
	call	anzeige
	return
kom_cqza_in:
	call	clear_buffer
	movlw	0c3h
	movwf	f_hf
	movlw	0d1h
	movwf	f_he
	movlw	0adh
	movwf	f_hd
	movlw	0dah
	movwf	f_hc
	movlw	0c1h
	movwf	f_hb
	movlw	0c8h
	movwf	f_ha
	movlw	0cch
	movwf	f_h9
	call	anzeige
	return
kom_wz_in:
	call	clear_buffer
	movlw	0d7h
	movwf	f_hf
	movlw	0c1h
	movwf	f_he
	movlw	0d2h
	movwf	f_hd
	movlw	0d4h
	movwf	f_hc
	movlw	0c5h
	movwf	f_hb
	call	anzeige
	return

kom_reset_in:
	call	clear_buffer
	movlw	0d2h
	movwf	f_hf
	movlw	0c5h
	movwf	f_he
	movlw	0d3h
	movwf	f_hd
	movlw	0c5h
	movwf	f_hc
	movlw	0d4h
	movwf	f_hb
	call	anzeige
	return

;=========================================================================
;Konfiguration der Taste UP
;=========================================================================
k_speed:
	movlw	b'01010110'
	call	zausg
	call	wpause
k_speed1:
	call        punkt
        movlw       1
        btfss       e_dash
        addwf       tempo,f
        btfss       e_dot
        subwf       tempo,f
        btfsc       e_start
        goto        k_speed1
        clrf        eing
	pagesel	femem
	call	    femem	
	clrf	pclath
	goto	    tloop

k_ton:	
	movlw	b'01010110'
	call	zausg
	call	wpause
k_ton1:
	call        strich
        movlw       1
        btfss       e_dash
        addwf       ton,f
        btfss       e_dot
        subwf       ton,f
        btfsc       e_start
        goto        k_ton1
        clrf        eing
	pagesel	femem
	call	    femem	
	clrf	pclath
	goto	    tloop

cq1_input:
	movlw	b'00110010'
	call	zausg
	clrf	bmem1
	movlw	sp_lang			;Buchstabenzaehler
	movwf	zaehler
	movlw	speicher1		;Speicherplatz
        banksel bank2
        movwf       eeadr
        banksel bank0
	clrf	cf
	goto	cq2_t0

cq2_input:
	movlw	b'00110010'
	call	zausg
	clrf	bmem1
	movlw	sp_lang			;Buchstabenzaehler 
	movwf	zaehler
	movlw	speicher2		;Speicherplatz
        banksel bank2
        movwf       eeadr
        banksel bank0
	clrf	cf
cq2_t0:
	movf	zaehler,w			
	sublw	sp_lang
	call	bin_bcd			;Display Zhlerstand
	pagesel	zeile2
	call	zeile2
	clrf	pclath
	call	fin
	movwf	bmem
	movf	bmem,f
	btfsc	status,z		;bernehmen?
	goto	cq2_t1
        call	wpause
        movf    bmem,w
	movwf	bmem1
        call    zausg			;echo
	goto	cq2_t0
cq2_t1:
	movf	cf,f
	btfss	status,z
	goto	cq2_end			;ende
	movf	bmem1,w
	btfsc	status,z
	goto	cq2_t3
	xorlw	b'00000000'
	andlw	b'11111100'
	btfsc	status,z		;Irrung eins zurck
	goto	cq2_ret
cq2_t2:	movf	bmem1,w
	pagesel	emem
	call	emem
	clrf	pclath
	clrf	bmem1
	decfsz	zaehler,f		;Speicher voll?
	goto	cq2_t0
	goto	cq1_config
cq2_t3:
	incf	cf,f
	goto	cq2_t2		
cq2_ret:				;Speicher -1
        banksel bank2
        decf    eeadr,f
        banksel bank0
	incf	zaehler,f
	clrf	bmem1	
	goto	cq2_t0

cq2_end:				;Stop Byte setzen
	movlw	0ffh
	pagesel	emem
	call	emem
	clrf	pclath
	goto	cq1_config

zf_change:
	btfss	cq_count,7
	goto	zf_m
	bcf	cq_count,7
	movlw	b'01101000'
	call	zausg
	goto	zf_end
zf_m:
	bsf	cq_count,7
	movlw	b'11100000'
	call	zausg
zf_end:	
	pagesel	femem
	call	femem
	clrf	pclath
	goto	kzf

zf_input:
	movlw	b'00110010'
	call	zausg
zf_in0: call        fin
        btfsc       status,z
        goto        zf_in1
        movwf       f_h0
        call        fin
        movwf       f_h1
        call        fin
        movwf       f_h2
        call        fin
        movwf       f_h3
        call        fin
        movwf       f_h4
        call        fin
        movwf       f_h5

        call        wpause
        movf        f_h0,w
        call        zausg        ;echo
        movf        f_h1,w
        call        zausg
        movf        f_h2,w
        call        zausg
        movf        f_h3,w
        call        zausg
        movf        f_h4,w
        call        zausg
        movf        f_h5,w
        call        zausg
        goto        zf_in0
zf_in1:
	clrf        zf_b2
        movf        f_h0,w
        call        dec
        addwf       zf_b2,f
        swapf       zf_b2,f
        movf        f_h1,w
        call        dec
        addwf       zf_b2,f

        clrf        zf_b1
        movf        f_h2,w
        call        dec
        addwf       zf_b1,f
        swapf       zf_b1,f
        movf        f_h3,w
        call        dec
        addwf       zf_b1,f

        clrf        zf_b0
        movf        f_h4,w
        call        dec
        addwf       zf_b0,f
        swapf       zf_b0,f
        movf        f_h5,w
        call        dec
        addwf       zf_b0,f
        clrf        eing
	pagesel	femem
	call	femem
	clrf	pclath
	goto	k_zf_in

delay_input:
	movlw	b'00110010'
	call	zausg
dl_in0: call        fin
        btfsc       status,z
        goto        dl_in1
        movwf       f_h0
        call        fin
        movwf       f_h1

        call        wpause
        movf        f_h0,w
        call        zausg        ;echo
        movf        f_h1,w
        call        zausg
        goto        dl_in0
dl_in1:
	clrf        txhi_mem
        movf        f_h0,w
        call        dec
        addwf       txhi_mem,f
        swapf       txhi_mem,f
        movf        f_h1,w
        call        dec
        addwf       txhi_mem,f
        clrf        eing
	pagesel	femem
	call	femem
	clrf	pclath
	goto	k_dl_in

tastv_input:
	movlw	b'00110010'
	call	zausg
tv_in0: call        fin
        btfsc       status,z
        goto        tv_in1
        movwf       f_h0
        call        fin
        movwf       f_h1

        call        wpause
        movf        f_h0,w
        call        zausg        ;echo
        movf        f_h1,w
        call        zausg
        goto        tv_in0
tv_in1:
	clrf        tastv
        movf        f_h0,w
        call        dec
        addwf       tastv,f
        swapf       tastv,f
        movf        f_h1,w
        call        dec
        addwf       tastv,f
        clrf        eing
	pagesel	femem
	call	femem
	clrf	pclath
	goto	k_tv_in

pausev_input:
	movlw	b'00110010'
	call	zausg
pv_in0: call        fin
        btfsc       status,z
        goto        pv_in1
        movwf       f_h0
        call        fin
        movwf       f_h1

        call        wpause
        movf        f_h0,w
        call        zausg        ;echo
        movf        f_h1,w
        call        zausg
        goto        pv_in0
pv_in1:
	clrf        pausev
        movf        f_h0,w
        call        dec
        addwf       pausev,f
        swapf       pausev,f
        movf        f_h1,w
        call        dec
        addwf       pausev,f
        clrf        eing
	pagesel	femem
	call	femem
	clrf	pclath
	goto	k_pv_in

call_input:
	movlw	b'00110010'
	call	zausg
	clrf	call1
	clrf	call2
	clrf	call3
	clrf	call4
	clrf	call5
	clrf	call6
	clrf	bmem1
	movlw	6			;Buchstabenzaehler 
	movwf	zaehler
	movlw	call1			;Speicherplatz
	movwf	fsr
	clrf	cf
call_t0:
	movf	zaehler,w			
	sublw	6
	call	bin_bcd			;Display Zhlerstand
	pagesel	zeile2
	call	zeile2
	clrf	pclath
	call	fin
	movwf	bmem
	movf	bmem,f
	btfsc	status,z		;bernehmen?
	goto	call_t1
        call	wpause
        movf    bmem,w
	movwf	bmem1
        call    zausg			;echo
	goto	call_t0
call_t1:
	movf	cf,f
	btfss	status,z
	goto	call_end		;ende
	movf	bmem1,w
	btfsc	status,z
	goto	call_t3
	xorlw	b'00000000'
	andlw	b'11111100'
	btfsc	status,z		;Irrung eins zurck
	goto	call_ret
call_t2:
	movf	bmem1,w
	movwf	indf
	incf	fsr,f
	clrf	bmem1
	decfsz	zaehler,f		;Speicher voll?
	goto	call_t0
	goto	call_end
call_t3:
	incf	cf,f
	goto	call_t2		
call_ret:				;Speicher -1
        decf    fsr,f
	incf	zaehler,f
	clrf	bmem1	
	goto	call_t0

call_end:	
	pagesel	femem
	call	femem			
	clrf	pclath
	call	starttext
	goto	k_cl_in

freq_input:
	movlw	b'00110010'
	call	zausg
fm_in0: call        fin
        btfsc       status,z
        goto        fm_in1
        movwf       f_h0
        call        fin
        movwf       f_h1

        call        wpause
        movf        f_h0,w
        call        zausg        ;echo
        movf        f_h1,w
        call        zausg
        goto        fm_in0
fm_in1:
	clrf        fmask
        movf        f_h0,w
        call        dec
        addwf       fmask,f
        swapf       fmask,f
        movf        f_h1,w
        call        dec
        addwf       fmask,f
        clrf        eing
	pagesel	femem
	call	femem
	clrf	pclath
	goto	k_fm_in

cqza_input:
	movlw	b'00110010'
	call	zausg
cq_in0: call        fin
        btfsc       status,z
        goto        cq_in1
        movwf       f_h0
        call        wpause
        movf        f_h0,w
        call        zausg        ;echo
        goto        cq_in0
cq_in1:
	movlw	80h
	andwf	cq_count,f
        movf        f_h0,w
        call        dec
	andlw	0fh
        addwf   cq_count,f
        clrf        eing
	pagesel	femem
	call	femem
	clrf	pclath
	goto	k_ca_in

wz_input:
	movlw	b'00110010'
	call	zausg
wz_in0: call        fin
        btfsc       status,z
        goto        wz_in1
        movwf       f_h0
        call        wpause
        movf        f_h0,w
        call        zausg        ;echo
        goto        wz_in0
wz_in1:
	movlw	8fh
	andwf	cq_count,f
        movf        f_h0,w
        call        dec
	movwf	f_h0
	swapf	f_h0,w
	andlw	70h
        addwf   cq_count,f
        clrf        eing
	pagesel	femem
	call	femem
	clrf	pclath
	goto	k_wz_in

;=========================================================================
;decodieren des Morsezeichens
;nur in mtab gltige werden erkannt
;=========================================================================
dec:    movwf       sr0
        clrf        decoder      ;decodieren
dec1:   movf        decoder,w
        call        mtab
        subwf       sr0,w
        btfsc       status,2
        goto        dec2
        incf        decoder,f
        movlw       10h
        subwf       decoder,w
        btfsc       status,0
        goto        dec3
        goto        dec1

dec2:   movf        decoder,w
        return

dec3:   clrw
        return


;=========================================================================
;neue ROM Bank
;0800
;=========================================================================
	org	800h

;=========================================================================
;Abspeichern der Daten im EEPROM 
;=========================================================================

femem:  movlw   ton                     ;ram anfang
        movwf   fsr
        movlw   10h                     ;Anzahl der byte
        movwf   z_anz
        movlw   0                       ;EEPROM Adresse
            
r_to_e:
        banksel bank2
        movwf       eeadr
        banksel bank0
r_to_e0:
        movf    indf,w
	call	    emem
        decfsz  z_anz,f
        goto    r_to_e0
	return

emem:   
        banksel bank2
        movwf       eedata
	banksel bank3
        bcf         eecon1,7
        bsf         eecon1,2
        movlw       55h
        movwf       eecon2
        movlw       0aah
        movwf       eecon2
        bsf         eecon1,1
etest:  btfsc       eecon1,1
        goto        etest
        bcf         eecon1,2
        banksel bank2
	incf	    eeadr,f
        banksel bank0
        incf    fsr,f
	return

;=========================================================================
;Holen der Daten aus dem EEPROM 
;=========================================================================

famem:  movlw   ton                     ;ram anfang
        movwf   fsr
        movlw   10h                     ;Anzahl der byte
        movwf   z_anz
        movlw   0                       ;EEPROM Adresse
            
e_to_r:
        banksel bank2
	movwf       eeadr
        banksel bank0
e_to_r0:
	call	    amem
	movwf	    indf
        incf    fsr,f
        decfsz  z_anz,f
        goto    e_to_r0
        return

amem:   
        banksel bank3
        bcf         eecon1,7
        bsf         eecon1,0
        banksel bank2
        movf        eedata,w
	incf	    eeadr,f
        banksel bank0
	return

;=========================================================================
;Zwischenfrequenz addieren 
;z:=9 000 000 Hz/10 =0d bb a0 Hex
;durch 10 dividieren da 100 ms Torzeit
;=========================================================================
addzf: 
        clrf        cf
        movf        zf_b0,w
        movwf       sum
        movf        z_b0,w
        call        adc
        movwf       z_b0

        movf        zf_b1,w
        movwf       sum
        movf        z_b1,w
        call        adc
        movwf       z_b1

        movf        zf_b2,w
        movwf       sum
        movf        z_b2,w
        call        adc
        movwf       z_b2

        return

adc:    addwf       cf,w
        btfss       status,0
        bcf         cf,0
        addwf       sum,w
        btfsc       status,0
        bsf         cf,0
        return

;=========================================================================
;Zwischenfrequenz subtrahieren
;z:=9 000 000 Hz/10 =0d bb a0 Hex
;durch 10 dividieren da 100 ms Torzeit
;=========================================================================
subzf: 
        clrf        cf
        movf        zf_b0,w
        movwf       sum
        movf        z_b0,w
        call        sbc
        movwf       z_b0

        movf        zf_b1,w
        movwf       sum
        movf        z_b1,w
        call        sbc
        movwf       z_b1

        movf        zf_b2,w
        movwf       sum
        movf        z_b2,w
        call        sbc
        movwf       z_b2

        return

sbc:    movwf       mem
        movf        cf,w
        subwf       mem,f
        btfsc       status,0
        bcf         cf,0
        movf        sum,w
        subwf       mem,w
        btfss       status,0
        bsf         cf,0
        return


reset_input:
	movlw	20h
	movwf	ton
	movlw	0b0h
	movwf	tempo
	movlw	3h
	movwf	cq_count
	clrf	zf_b2
	clrf	zf_b1
	clrf	zf_b0
	movlw	80h
	movwf	txhi_mem
	movlw	0f8h
	movwf	fmask

	movlw	b'11001000'	;Z
	movwf	call1
	movlw	b'01000000'	;E
	movwf	call2
	movlw	b'11100000'	;M
	movwf	call3
	clrf	call4
	clrf	call5
	clrf	call6
	movlw	31h
	movwf	tastv
	movlw	64h
	movwf	pausev
	call	femem
	return

;********************************
	if lcdtype == 1
;********************************

;=========================================================================
;I2C Softwareroutinen
;=========================================================================

err:    
	clrf	pclath
	goto	i2cerr
;
;-------------------------------------------------------------------------
;       start bus communication routine
;-------------------------------------------------------------------------
;       input   : none
;       output  : initialize bus communication
;-------------------------------------------------------------------------
;
;generate start bit (scl is high while sda goes from high to low transition)
;and check status of the serial clock.
bstart
        movlw   i2cout     	; put scl, sda line in output state

	banksel bank1		; registerbank 80h..0afh
	movwf	trisc		; port c i/o aenderung
	banksel bank0		; registerbank 0..2fh

        bsf     a_sda           ; make sure sda is high

        bsf     a_scl           ; set clock high
        movlw   1               ; ready error status code 1
        btfss   a_scl           ; locked?
        goto    err             ; scl locked low by device
        bcf     a_sda           ; sda goes low during scl high
        nop                     ; timing adjustment
        nop
        nop
        bcf     a_scl           ; start clock train
        retlw   0
;
;-------------------------------------------------------------------------
;       stop bus communication routine
;-------------------------------------------------------------------------
;       input   :       none
;       output  :       bus communication, stop condition
;-------------------------------------------------------------------------
;
;generate stop bit (sda goes from low to high during scl high state)
;and check bus conditions.
;
bstop
        bcf     a_sda           ; return sda to low
        bsf     a_scl           ; set scl high
        nop
        nop
        nop
        movlw   1               ; ready error code 1
        btfss   a_scl           ; high?
        goto    err             ; no, scl locked low by device
        bsf     a_sda           ; sda goes from low to high during scl high
        movlw   4               ; ready error code 4
        btfss   a_sda           ; high?
        goto    err             ; no, sda bus not release for stop

        movlw   i2cin     	; put scl, sda line in input state

	banksel bank1		; registerbank 80h..0afh
	movwf	trisc		; port c i/o aenderung
	banksel bank0		; registerbank 0..2fh

        retlw   0
;

;
;-------------------------------------------------------------------------
;       serial data bit receive from i2c Bus
;-------------------------------------------------------------------------
;       input   :       none
;       output  :       
;-------------------------------------------------------------------------
;
bitin
        movlw   i2csdain     	; force sda line as input

	banksel bank1		; registerbank 80h..0afh
	movwf	trisc		; port c i/o aenderung
	banksel bank0		; registerbank 0..2fh

        bcf     bitbuf,di
        bsf     a_scl          	; clock high
        movlw   1
        btfsc   a_scl          	; skip if scl  is high
        goto    bit1
        btfss   flag,err1       ; remain as first error encountered
        movwf   ercode          ; save error code
        bsf     flag,err1       ; set error flag
bit1
        btfsc   a_sda          	; read sda pin
        bsf     bitbuf,di       ; di = 1
        nop                     ; delay
        bcf     a_scl          	; return scl to low     
        retlw   0
;
;-------------------------------------------------------------------------
;       serial data send bit to i2c bus
;-------------------------------------------------------------------------
;       input   :       
;       output  :       
;-------------------------------------------------------------------------
;
bitout:
        movlw   i2cout     	; put scl, sda line in output state

	banksel bank1		; registerbank 80h..0afh
	movwf	trisc		; port c i/o aenderung
	banksel bank0		; registerbank 0..2fh

        btfss   bitbuf,do
        goto    bit0
        bsf     a_sda          	; output bit 0
        movlw   2
        btfsc   a_sda          	; check for error code 2
        goto    clk1
        btfss   flag,err1       ; remain as first error encountered
        movwf   ercode          ; save error code
        bsf     flag,err1       ; set error flag
        goto    clk1            ; sda locked low by device
;
bit0
        bcf     a_sda          	; output bit 0
        nop                     ; delay
        nop
        nop
clk1
        bsf     a_scl
        movlw   1               ; error code 1
        btfsc   a_scl          	; scl locked low?
        goto    bit2            ; no.
        btfss   flag,err1       ; yes.
        movwf   ercode          ; save error code
        bsf     flag,err1       ; set error flag
bit2
        nop
        nop
        bcf     a_scl          ; return scl to low
        retlw   0
;
;-------------------------------------------------------------------------
;       receive         data    subroutine
;-------------------------------------------------------------------------
;       input   :       none
;       output  :       rxbuf = receive 8-bit data
;-------------------------------------------------------------------------
;

rx
        movlw   8              ; 8 bits of data
        movwf   count
        clrf    rxbuf
;
rxlp
        rlf     rxbuf, f        ; shift data to buffer
        skpc
        bcf     rxbuf,0         ; carry ---> f(0)
        skpnc
        bsf     rxbuf,0
        call    bitin
        btfsc   bitbuf,di
        bsf     rxbuf,0         ; input bit =1
        decfsz  count, f        ; 8 bits?
        goto    rxlp
        bsf     bitbuf,do       ; set acknowledge bit = 1
        call    bitout          ; to stop further input
        retlw   0

;-------------------------------------------------------------------------
;       transmit        data    subroutine
;-------------------------------------------------------------------------
;       input   :       txbuf
;       output  :       data x'mitted to bitbuf device
;-------------------------------------------------------------------------
;
ztx	movwf	txbuf		;testen ob ASCII Text mit gesetzten bit 7
	btfss	txbuf,7
        iorlw   0b0h		; nur bcd ziffer + 30h + 80h
ktx     movwf   txbuf           ; ... into buffer

tx
        movlw   8
        movwf   count
;
txlp
        bcf     bitbuf,do       ; shift data bit out.
        btfsc   txbuf,7         ; if shifted bit = 0, data bit = 0
        bsf     bitbuf,do       ; otherwise data bit = 1
        call    bitout          ; serial data out
        rlf     txbuf, f        ; rotate txbuf left
        skpc                    ; f(6) ---> f(7)
        bcf     txbuf,0         ; f(7) ---> carry
        skpnc                   ; carry ---> f(0)
        bsf     txbuf,0

        decfsz  count, f        ; 8 bits done?
        goto    txlp            ; no.
        call    bitin           ; read acknowledge bit
        movlw   3
        btfsc   bitbuf,di       ; check for acknowledgement
        goto    err             ; no acknowledge from device
        retlw   0


;-------------------------------------------------------------------------
;       byte-write, write one byte to bitbuf device
;-------------------------------------------------------------------------
;       input   :       datao= data to be written
;                       addr    = destination address
;                       slave   = device address (1010xxx0)
;       output  :       data written to bitbuf device
;-------------------------------------------------------------------------

lcd_init
	btfsc	flag,nodisp
	return
        movlw   74h             ; get slave address
        movwf   txbuf           ; ... to tx buffer
        call    bstart          ; generate start bit
        call    tx              ; output slave address
        movlw   00h             ; 
        call    ktx             ; 
        movlw   25h             ; 
        call    ktx             ; 
        movlw   06h             ;
        call    ktx             ; 
        movlw   24h             ; 
        call    ktx             ; 
        movlw   0ch             ; 
        call    ktx             ; 
        movlw   84h             ; 
        call    ktx             ; 
        call    bstop           ; generate stop bit
        return
lcd_clear
	btfsc	flag,nodisp
	return
        movlw   74h             ; get slave address
        movwf   txbuf           ; ... to tx buffer
        call    bstart          ; generate start bit
        call    tx              ; output slave address
        movlw   00h             ; 
        call    ktx             ; 
        movlw   01h             ; 
        call    ktx             ; 
        movlw   84h             ; 
        call    ktx             ; 
        call    bstop           ; generate stop bit
        return

zeile1:
	btfsc	flag,nodisp
	return
        movlw   74h             ; get slave address
        movwf   txbuf           ; ... to tx buffer
        call    bstart          ; generate start bit
        call    tx              ; output slave address
        movlw   00h             ; 
        call    ktx             ; 
        movlw   084h            ; 
        call    ktx             ; 
        call    bstop           ; generate stop bit
	nop

        movlw   74h             ; get slave address
        movwf   txbuf           ; ... to tx buffer
        call    bstart          ; generate start bit
        call    tx              ; output slave address
        movlw   40h             ; move data 
        call    ktx             ; output data and detect acknowledgement
        movf    f_hf,w          ; 
        call    ztx             ; 
        movf    f_he,w          ; 
        call    ztx             ; 
        movf    f_hd,w          ; 
        call    ztx             ; 
        movf    f_hc,w          ; 
        call    ztx             ; 
        movf    f_hb,w          ; 
        call    ztx             ; 
        movf    f_ha,w          ; 
        call    ztx             ; 
        movf    f_h9,w          ; 
        call    ztx             ; 
        movf    f_h8,w          ; 
        call    ztx             ; 
        call    bstop           ; generate stop bit
        return
zeile2
	btfsc	flag,nodisp
	return
        movlw   74h             ; get slave address
        movwf   txbuf           ; ... to tx buffer
        call    bstart          ; generate start bit
        call    tx              ; output slave address
        movlw   00h             ; move data 
        call    ktx             ; output data and detect acknowledgement
        movlw   0c4h            ; move data 
        call    ktx             ; output data and detect acknowledgement
        call    bstop           ; generate stop bit

        movlw   74h             ; get slave address
        movwf   txbuf           ; ... to tx buffer
        call    bstart          ; generate start bit
        call    tx              ; output slave address
        movlw   40h             ; move data 
        call    ktx             ; output data and detect acknowledgement
        movf    f_h7,w          ; 
        call    ztx             ; 
        movf    f_h6,w          ; 
        call    ztx             ; 
        movf    f_h5,w          ; 
        call    ztx             ; 
        movf    f_h4,w          ; 
        call    ztx             ; 
        movf    f_h3,w          ; 
        call    ztx             ; 
        movf    f_h2,w          ; 
        call    ztx             ; 
        movf    f_h1,w          ; 
        call    ztx             ; 
        movf    f_h0,w          ; 
        call    ztx             ; 
        call    bstop           ; generate stop bit
        return

;********************************
	else
;********************************

;=========================================================================
;Init groes LCD Display
;=========================================================================

lcd_init:
				; nach dem Einschalten Wartezeit durch
				; Morseausgabe des Calls
	movlw	2h		;noch im 8 Bit Modus 4 Bit vorbereiten
	movwf	portc
	bsf	lcd_enable
	nop
	nop
	bcf	lcd_enable
	call	warte		
	call	warte		
	call	warte		
	call	warte		
	movlw	28h		;4 bit Funktion 2 Zeilen
	call	com
	movlw	0ch		;Display an, Cursor aus
	call	com
	movlw	06h		;increment cursor
	call	com
	movlw	01h		;display clear
	call	com

	movlw	'Z'		;Funktionstest LC-Display
	call	lcd		;oder 1. Zeile
	movlw	'E'
	call	lcd
	movlw	'M'
	call	lcd
	movlw	' '
	call	lcd
	movlw	'D'
	call	lcd
	movlw	'K'
	call	lcd
	movlw	'3'
	call	lcd
	movlw	'W'
	call	lcd
	movlw	'X'
	call	lcd
	return			; nicht RETURN zum Testen

endl:	goto	endl



;=========================================================================
;Ausgabe grosses LCD
;=========================================================================
zeile1:
;********************************
	if zeile == 2
;********************************
	movlw	0c0h		;
;********************************
	else
;********************************
	movlw	080h		;
;********************************
	endif
;********************************
	call	com
        movf    f_hf,w          ; 
        call    lcd_ztx         ; 
        movf    f_he,w          ; 
        call    lcd_ztx         ; 
        movf    f_hd,w          ; 
        call    lcd_ztx         ; 
        movf    f_hc,w          ; 
        call    lcd_ztx         ; 
        movf    f_hb,w          ; 
        call    lcd_ztx         ; 
        movf    f_ha,w          ; 
        call    lcd_ztx         ; 
        movf    f_h9,w          ; 
        call    lcd_ztx         ; 
        movf    f_h8,w          ; 
        call    lcd_ztx         ; 
	return

zeile2:
;********************************
	if zeile == 2
;********************************
	movlw	0c8h		;
;********************************
	else
;********************************
	movlw	0c0h		;
;********************************
	endif
;********************************
	call	com
        movf    f_h7,w          ; 
        call    lcd_ztx         ; 
        movf    f_h6,w          ; 
        call    lcd_ztx         ; 
        movf    f_h5,w          ; 
        call    lcd_ztx         ; 
        movf    f_h4,w          ; 
        call    lcd_ztx         ; 
        movf    f_h3,w          ; 
        call    lcd_ztx         ; 
        movf    f_h2,w          ; 
        call    lcd_ztx         ; 
        movf    f_h1,w          ; 
        call    lcd_ztx         ; 
        movf    f_h0,w          ; 
        call    lcd_ztx         ; 
	return

lcd_ztx:
	movwf	temp
	btfsc	temp,7
	goto	lcd_ztx0
	movlw	30h
	addwf	temp,w
	call	lcd
	return
lcd_ztx0:
	bcf	temp,7
	movf	temp,w
	call	lcd
	return

;=========================================================================
;Uebertragung von Zeichen an's LCD 
;=========================================================================
lcd:	movwf	temp
	call	lcd_busy
	bsf	lcd_rs		;rs auf Daten schreiben   
	call	lcd_write
	return

;=========================================================================
;Uebertragung von Kommandos an's LCD 
;=========================================================================
com:	movwf	temp
	call	lcd_busy
	bcf	lcd_rs		;rs auf Komm. schreiben   
	call	lcd_write
	return

;=========================================================================
;LCD-Subroutinen 
;=========================================================================
warte:	movlw	0ffh
	movwf	temp1
war1:	decfsz	temp,f
	goto	war1
	decfsz	temp1,f
	goto	war1
	return

lcd_busy:
	bcf	lcd_rs		;rs auf Kommandomode
	bsf	lcd_rw		;r/w auf lesen       
	movlw	00fh
        banksel	bank1		
	movwf	trisc		;Port c Bit 0..3 Eingang 
        banksel	bank0		
busy:	bsf	lcd_enable	;enable
	nop
	nop
	movf	portc,w
	movwf	bmem
     	bcf	lcd_enable	;disable
	nop   
	nop
	nop   
	nop
	bsf	lcd_enable	;enable
	nop
	nop
	nop   
	nop
     	bcf	lcd_enable	;disable
	btfsc	bmem,3
	goto	busy
	movlw	00h
        banksel	bank1		
	movwf	trisc		;Port C alles Ausgang		
        banksel	bank0
	return

lcd_write:
	bcf	lcd_rw		;r/w auf schreiben   

	movlw	0f0h
	andwf	portc,f		; Bit 0..3 auf Null setzen
	swapf	temp,w		;high Nibble holen
	andlw	0fh		; und das andere Nibble lschen
	iorwf	portc		;Ausgabe
 
     	bsf	lcd_enable	;enable
	nop   
	nop
	nop   
	nop
     	bcf	lcd_enable	;disable

	movlw	0f0h
	andwf	portc,f		; Bit 0..3 auf Null setzen
	movf	temp,w		;low Nibble holen
	andlw	0fh		; und das andere Nibble lschen
	iorwf	portc		;Ausgabe

     	bsf	lcd_enable	;enable
	nop   
	nop
	nop   
	nop
     	bcf	lcd_enable	;disable
	bcf	lcd_rs		;rs auf Kommandomode
	return
		
;********************************
	endif
;********************************

       end
